import "./TreeView.5c7cb24b.css";
import {UNSTABLE_Tree as $FHprs$UNSTABLE_Tree, Collection as $FHprs$Collection, UNSTABLE_TreeItem as $FHprs$UNSTABLE_TreeItem, UNSTABLE_TreeItemContent as $FHprs$UNSTABLE_TreeItemContent, useContextProps as $FHprs$useContextProps, ButtonContext as $FHprs$ButtonContext} from "react-aria-components";
import {Checkbox as $FHprs$Checkbox} from "@react-spectrum/checkbox";
import $FHprs$spectrumiconsuiChevronLeftMedium from "@spectrum-icons/ui/ChevronLeftMedium";
import $FHprs$spectrumiconsuiChevronRightMedium from "@spectrum-icons/ui/ChevronRightMedium";
import {isAndroid as $FHprs$isAndroid} from "@react-aria/utils";
import $FHprs$react, {createContext as $FHprs$createContext, useContext as $FHprs$useContext, isValidElement as $FHprs$isValidElement, useRef as $FHprs$useRef} from "react";
import {useStyleProps as $FHprs$useStyleProps, useDOMRef as $FHprs$useDOMRef, SlotProvider as $FHprs$SlotProvider} from "@react-spectrum/utils";
import {Text as $FHprs$Text} from "@react-spectrum/text";
import {useButton as $FHprs$useButton} from "@react-aria/button";
import {useLocale as $FHprs$useLocale} from "@react-aria/i18n";

/*
 * Copyright 2024 Adobe. All rights reserved.
 * This file is licensed to you under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. You may obtain a copy
 * of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS
 * OF ANY KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */ 









const $48b8113347121625$var$TreeRendererContext = /*#__PURE__*/ (0, $FHprs$createContext)({});
function $48b8113347121625$var$useTreeRendererContext() {
    return (0, $FHprs$useContext)($48b8113347121625$var$TreeRendererContext);
}
// TODO: add animations for rows appearing and disappearing
// TODO: the below is needed so the borders of the top and bottom row isn't cut off if the TreeView is wrapped within a container by always reserving the 2px needed for the
// keyboard focus ring. Perhaps find a different way of rendering the outlines since the top of the item doesn't
// scroll into view due to how the ring is offset. Alternatively, have the tree render the top/bottom outline like it does in Listview
const $48b8113347121625$var$tree = function anonymous(props) {
    let rules = "";
    rules += ' wc';
    rules += ' xc';
    rules += ' ua';
    rules += ' va';
    rules += ' __ka';
    rules += ' Aa';
    rules += ' ca___y';
    rules += ' ca';
    if (props.isEmpty) rules += ' _Vd';
    if (props.isEmpty) rules += ' _Uc';
    if (props.isEmpty) rules += ' oY';
    if (props.isEmpty) rules += ' nY';
    if (props.isEmpty) rules += ' _Sd';
    return rules;
};
function $48b8113347121625$var$TreeView(props, ref) {
    let { children: children, selectionStyle: selectionStyle } = props;
    let renderer;
    if (typeof children === 'function') renderer = children;
    let { styleProps: styleProps } = (0, $FHprs$useStyleProps)(props);
    let domRef = (0, $FHprs$useDOMRef)(ref);
    let selectionBehavior = selectionStyle === 'highlight' ? 'replace' : 'toggle';
    return /*#__PURE__*/ (0, $FHprs$react).createElement($48b8113347121625$var$TreeRendererContext.Provider, {
        value: {
            renderer: renderer
        }
    }, /*#__PURE__*/ (0, $FHprs$react).createElement((0, $FHprs$UNSTABLE_Tree), {
        ...props,
        ...styleProps,
        className: ({ isEmpty: isEmpty })=>$48b8113347121625$var$tree({
                isEmpty: isEmpty
            }),
        selectionBehavior: selectionBehavior,
        ref: domRef
    }, props.children));
}
const $48b8113347121625$var$treeRow = function anonymous(props) {
    let rules = "";
    rules += ' Xc';
    rules += ' _Sd';
    rules += ' nk';
    rules += ' oY';
    rules += ' __ka';
    rules += ' _6c';
    rules += ' _7d';
    rules += ' _9b';
    rules += ' a___K';
    rules += ' _Ea';
    if (props.isLink) rules += ' __Ec';
    else rules += ' __Eb';
    if (props.isSelected) rules += ' b-7vr0l1';
    else if (props.isPressed) rules += ' b-1t6gvb8';
    else if (props.isFocusVisibleWithin) rules += ' b-ml9cvk';
    else if (props.isHovered) rules += ' b-ml9cvk';
    return rules;
};
const $48b8113347121625$var$treeCellGrid = function anonymous(props) {
    let rules = "";
    rules += ' _Sf';
    rules += ' oY';
    rules += ' _Uc';
    rules += ' __d-1nxidkl-1nxidkl-1nxidkl-3hmti-1nxidkl-375yi6-1nxidkl-ykdwf2';
    rules += ' __e-375yi6';
    rules += ' __f-1qk85yo';
    if (props.isDisabled) {
        rules += ' aa___F';
        rules += ' ai';
    }
    return rules;
};
// TODO: These styles lose against the spectrum class names, so I've did unsafe for the ones that get overridden
const $48b8113347121625$var$treeCheckbox = function anonymous(props) {
    let rules = "";
    rules += ' __g-4wahvw';
    rules += ' _J-37nn5o';
    rules += ' Cd';
    rules += ' Da';
    return rules;
};
const $48b8113347121625$var$treeIcon = function anonymous(props) {
    let rules = "";
    rules += ' __g-ykjmzy';
    rules += ' Dc';
    return rules;
};
const $48b8113347121625$var$treeContent = function anonymous(props) {
    let rules = "";
    rules += ' __g-1mod4sg';
    rules += ' _ga';
    rules += ' _kb';
    rules += ' __sb';
    rules += ' __tb';
    return rules;
};
const $48b8113347121625$var$treeActions = function anonymous(props) {
    let rules = "";
    rules += ' __g-8ayfo6';
    rules += ' _3-3t1x';
    rules += ' _2-3t1x';
    rules += ' CF';
    rules += ' Db';
    return rules;
};
const $48b8113347121625$var$treeActionMenu = function anonymous(props) {
    let rules = "";
    rules += ' __g-wit6hk';
    rules += ' oi';
    return rules;
};
const $48b8113347121625$var$treeRowOutline = function anonymous(props) {
    let rules = "";
    rules += ' _Sa';
    rules += ' Xa';
    rules += ' Ya';
    rules += ' Za';
    if (props.isSelected) {
        if (props.isFocusVisible) rules += ' _0-yj8a3w';
        else rules += ' _0-yj899n';
    } else if (props.isFocusVisible) rules += ' _0-yj8a3w';
    else rules += ' _0a';
    rules += ' _2a';
    rules += ' __ya';
    rules += ' _tb';
    if (props.isSelected) {
        if (props.isFocusVisible) rules += ' _oa-4bhpmf';
        else rules += ' _oa-zlnqab';
    } else if (props.isFocusVisible) rules += ' _oa-4bhpmf';
    if (props.isSelected) {
        if (props.isFocusVisible) rules += ' _o-ba5uxf';
        else rules += ' _o-1ytnijz';
    } else if (props.isFocusVisible) rules += ' _o-ba5uxf';
    return rules;
};
const $48b8113347121625$export$6e77ea6719814e9c = (props)=>{
    let { children: children, childItems: childItems, hasChildItems: hasChildItems, href: href } = props;
    let content;
    let nestedRows;
    let { renderer: renderer } = $48b8113347121625$var$useTreeRendererContext();
    // TODO alternative api is that we have a separate prop for the TreeItems contents and expect the child to then be
    // a nested tree item
    if (typeof children === 'string') content = /*#__PURE__*/ (0, $FHprs$react).createElement((0, $FHprs$Text), null, children);
    else {
        content = [];
        nestedRows = [];
        (0, $FHprs$react).Children.forEach(children, (node)=>{
            if (/*#__PURE__*/ (0, $FHprs$isValidElement)(node) && node.type === $48b8113347121625$export$6e77ea6719814e9c) nestedRows.push(node);
            else content.push(node);
        });
    }
    if (childItems != null && renderer) nestedRows = /*#__PURE__*/ (0, $FHprs$react).createElement((0, $FHprs$Collection), {
        items: childItems
    }, renderer);
    return(// TODO right now all the tree rows have the various data attributes applied on their dom nodes, should they? Doesn't feel very useful
    /*#__PURE__*/ (0, $FHprs$react).createElement((0, $FHprs$UNSTABLE_TreeItem), {
        ...props,
        className: (renderProps)=>$48b8113347121625$var$treeRow({
                ...renderProps,
                isLink: !!href
            })
    }, /*#__PURE__*/ (0, $FHprs$react).createElement((0, $FHprs$UNSTABLE_TreeItemContent), null, ({ isExpanded: isExpanded, hasChildRows: hasChildRows, level: level, selectionMode: selectionMode, selectionBehavior: selectionBehavior, isDisabled: isDisabled, isSelected: isSelected, isFocusVisible: isFocusVisible })=>/*#__PURE__*/ (0, $FHprs$react).createElement("div", {
            className: $48b8113347121625$var$treeCellGrid({
                isDisabled: isDisabled
            })
        }, selectionMode !== 'none' && selectionBehavior === 'toggle' && // TODO: add transition?
        /*#__PURE__*/ (0, $FHprs$react).createElement((0, $FHprs$Checkbox), {
            isEmphasized: true,
            UNSAFE_className: $48b8113347121625$var$treeCheckbox(),
            UNSAFE_style: {
                paddingInlineEnd: '0px'
            },
            slot: "selection"
        }), /*#__PURE__*/ (0, $FHprs$react).createElement("div", {
            style: {
                gridArea: 'level-padding',
                marginInlineEnd: `calc(${level - 1} * var(--spectrum-global-dimension-size-200))`
            }
        }), (hasChildRows || hasChildItems) && /*#__PURE__*/ (0, $FHprs$react).createElement($48b8113347121625$var$ExpandableRowChevron, {
            isDisabled: isDisabled,
            isExpanded: isExpanded
        }), /*#__PURE__*/ (0, $FHprs$react).createElement((0, $FHprs$SlotProvider), {
            slots: {
                text: {
                    UNSAFE_className: $48b8113347121625$var$treeContent({
                        isDisabled: isDisabled
                    })
                },
                // Note there is also an issue here where these icon props are making into the action menu's icon. Resolved by 8ab0ffb276ff437a65b365c9a3be0323a1b24656
                // but could crop up later for other components
                icon: {
                    UNSAFE_className: $48b8113347121625$var$treeIcon(),
                    size: 'S'
                },
                actionButton: {
                    UNSAFE_className: $48b8113347121625$var$treeActions(),
                    isQuiet: true
                },
                actionGroup: {
                    UNSAFE_className: $48b8113347121625$var$treeActions(),
                    isQuiet: true,
                    density: 'compact',
                    buttonLabelBehavior: 'hide',
                    isDisabled: isDisabled,
                    overflowMode: 'collapse'
                },
                actionMenu: {
                    UNSAFE_className: $48b8113347121625$var$treeActionMenu(),
                    UNSAFE_style: {
                        marginInlineEnd: '.5rem'
                    },
                    isQuiet: true
                }
            }
        }, content), /*#__PURE__*/ (0, $FHprs$react).createElement("div", {
            className: $48b8113347121625$var$treeRowOutline({
                isFocusVisible: isFocusVisible,
                isSelected: isSelected
            })
        }))), nestedRows));
};
const $48b8113347121625$var$expandButton = function anonymous(props) {
    let rules = "";
    rules += ' __g-pn4rxq';
    rules += ' nY';
    rules += ' _4b';
    rules += ' _Sd';
    rules += ' _0a';
    rules += ' _Tb';
    rules += ' _Vd';
    rules += ' _Ea';
    if (props.isExpanded) {
        if (props.isRTL) rules += ' W-negfvv';
        else rules += ' W-10b8jr2';
    }
    rules += ' _H-1o2fh9e';
    return rules;
};
function $48b8113347121625$var$ExpandableRowChevron(props) {
    let expandButtonRef = (0, $FHprs$useRef)(null);
    let [fullProps, ref] = (0, $FHprs$useContextProps)({
        ...props,
        slot: 'chevron'
    }, expandButtonRef, (0, $FHprs$ButtonContext));
    let { isExpanded: isExpanded, isDisabled: isDisabled } = fullProps;
    let { direction: direction } = (0, $FHprs$useLocale)();
    // Will need to keep the chevron as a button for iOS VO at all times since VO doesn't focus the cell. Also keep as button if cellAction is defined by the user in the future
    let { buttonProps: buttonProps } = (0, $FHprs$useButton)({
        ...fullProps,
        elementType: 'span'
    }, ref);
    return /*#__PURE__*/ (0, $FHprs$react).createElement("span", {
        ...buttonProps,
        ref: ref,
        // Override tabindex so that grid keyboard nav skips over it. Needs -1 so android talkback can actually "focus" it
        tabIndex: (0, $FHprs$isAndroid)() && !isDisabled ? -1 : undefined,
        className: $48b8113347121625$var$expandButton({
            isExpanded: isExpanded,
            isDisabled: isDisabled,
            isRTL: direction === 'rtl'
        })
    }, direction === 'ltr' ? /*#__PURE__*/ (0, $FHprs$react).createElement((0, $FHprs$spectrumiconsuiChevronRightMedium), null) : /*#__PURE__*/ (0, $FHprs$react).createElement((0, $FHprs$spectrumiconsuiChevronLeftMedium), null));
}
/**
 * A tree view provides users with a way to navigate nested hierarchical information.
 */ const $48b8113347121625$export$6940b0d9c820eca7 = /*#__PURE__*/ (0, $FHprs$react).forwardRef($48b8113347121625$var$TreeView);


export {$48b8113347121625$export$6e77ea6719814e9c as TreeViewItem, $48b8113347121625$export$6940b0d9c820eca7 as TreeView};
//# sourceMappingURL=TreeView.module.js.map
